%define  RELEASE 1
%define  rel     %{?CUSTOM_RELEASE} %{!?CUSTOM_RELEASE:%RELEASE}
%define  prefix  /usr
%define  sysconfdir	/etc

Summary: the GNOME spreadsheet
Name: 		gnumeric
Version: 	0.55
Release: 	%rel
Copyright: 	GPL
Group: 		Applications/Spreadsheets
Source: ftp://ftp.gnome.org/pub/GNOME/sources/gnumeric/gnumeric-%{version}.tar.gz
Url:		http://www.gnome.org/gnumeric
BuildRoot:	/var/tmp/%{name}-%{PACKAGE_VERSION}-root
Docdir: 	%{prefix}/doc

Requires: gtk+ >= 1.2.7
Requires: gnome-libs >= 1.0.57
Requires: gnome-print >= 0.20
Requires: libglade >= 0.13
Requires: libxml >= 1.8.5

%description
GNOME (GNU Network Object Model Environment) is a user-friendly set of
applications and desktop tools to be used in conjunction with a window
manager for the X Window System.  GNOME is similar in purpose and scope
to CDE and KDE, but GNOME is based completely on free software.

This is the Gnumeric, the GNOME spreadsheet program. If you are familiar with 
Excel, you should be ready to use Gnumeric.  We have tried to clone all of 
the good features and stay as compatible as possible with Excel in terms of 
usability. Hopefully we left the bugs behind :).

%prep
%setup -q

%build
%ifarch alpha
  MYARCH_FLAGS="--host=alpha-redhat-linux"
%endif
# Configure only showing me failures.
CFLAGS="$RPM_OPT_FLAGS" \
./configure --quiet --prefix=%prefix --sysconfdir=%{sysconfdir} \
            --without-bonobo --without-gb $MYARCH_FLAGS 

if [ "$SMP" != "" ]; then
	make -j$SMP "MAKE=make -j$SMP"
else
	make
fi

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

make prefix=$RPM_BUILD_ROOT%{prefix} sysconfdir=$RPM_BUILD_ROOT%{sysconfdir} install
#
# Auto detect the lang files.
#
if [ -f /usr/lib/rpm/find-lang.sh ] ; then
 /usr/lib/rpm/find-lang.sh $RPM_BUILD_ROOT %name
 sed "s:(644, root, root, 755):(444, bin, bin, 555):" %{name}.lang \
 >tmp.lang && mv tmp.lang %{name}.lang
fi


%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%files -f %{name}.lang

%defattr (0555, bin, bin)
%{prefix}/bin/gnumeric
%{prefix}/lib/gnumeric/%{version}/plugins/*.so

%{prefix}/share/gnumeric/%{version}/python/*
%{prefix}/share/gnumeric/%{version}/glade/*.glade

%defattr (0444, bin, man, 0555)
%{prefix}/share/gnome/help/gnumeric/C/images/*
%{prefix}/share/gnome/help/gnumeric/C/*.html
%{prefix}/share/gnome/help/gnumeric/C/*.dat
%{prefix}/share/gnome/help/gnumeric/C/docbook.css
%config %{prefix}/share/gnome/apps/Applications/gnumeric.desktop
%{prefix}/share/pixmaps/gnumeric/*
%{prefix}/share/pixmaps/gnome-gnumeric.png
%{prefix}/share/mime-info/gnumeric.keys
%{prefix}/share/mime-info/gnumeric.mime
%{prefix}/share/mc/templates/gnumeric.desktop


%defattr (0444, bin, bin, 555)
# This should go in a devel package...
%{prefix}/share/idl/*.idl
%config %{sysconfdir}/CORBA/servers/gnumeric.gnorba
%doc HACKING AUTHORS ChangeLog NEWS README COPYING TODO

%changelog
* Sat May 20 2000 Jody Goldberg <jgolbderg@home.com>
- Updated version requirements for gnome-print, and libglade.

* Mon May 15 2000 Karl Eichwalder <ke@suse.de>
- Use %{version}, %{name} and %{sysconfdir} more consistently.
- Avoid long lines.

* Thu Mar 29 2000 Kjartan Maraas <kmaraas@online.no>
- Removed gnome-gnumeric-xl.png since it is nowhere to be found.
- Added --without-bonobo and --without-gb.
- Added %define for sysconfdir

* Mon Feb 29 2000 Jody Goldberg <jgolbderg@home.com>
- Updated version requirements for gnome-print, and gnome-libs.

* Sun Jan 30 2000 Gregory McLean <gregm@comstar.net>
- Added in some auto-detect the language files logic (rpm 3.0.xx only)

* Mon Jan 12 2000 Jody Goldberg <jgolbderg@home.com>
- Add depend on gtk+ >= 1.2.2 so that we can get gtk_object_get.

* Mon Jan 03 2000 Gregory McLean <gregm@comstar.net>
- Updated to 0.47

* Mon Dec 20 1999 Jody Goldberg <jgolbderg@home.com>
- Updated the libglade dependancy.
- Remove req for guile.  We can build without it.

* Thu Sep 02 1999 Gregory McLean <gregm@comstar.net>
- Added small fix so glade generated dialogs appear.

* Wed Jul 14 1999 Gregory McLean <gregm@comstar.net>
- Added the gnome-print requirement.
- Updated the file list to try and quiet down the updating.
- added the sysconfdir

* Tue Mar 9  1999 Gregory McLean <gregm@comstar.net>
- Updated the spec file.

* Thu Sep 24 1998 Michael Fulbright <msf@redhat.com>
- Version 0.2

